﻿# 8-puzzle.py
# Hilfe zum Problem: http://de.wikipedia.org/wiki/15-Puzzle
# Zur einfacheren Behandlung wird das leere Feld mit dem Wert 0 belegt.

ziel=[[1,2,3],[4,5,6],[7,8,0]]

def findeZeile(feld, wert):
    for zeilenIndex in range(3):
        if wert in feld[zeilenIndex]: return zeilenIndex
def findeSpalte(zeile, wert):
    for spaltenIndex in range(3):
        if wert == zeile[spaltenIndex]: return spaltenIndex
def findePosition(feld, wert):
    if not wert in range(9): return False 
    z=findeZeile(feld, wert)
    s=findeSpalte(feld[z], wert)
    return (z, s)
# Test: position=findePosition(ziel, 3)
def differenz(position, leer):
    return (abs(position[0]-leer[0]),abs(position[1]-leer[1]))
# Test: differenz((2,2), (2,1))

def setze(feld, zahl):
    if not zahl in range(1,9): return feld # unzulässiger Wert
    gewaehlt=findePosition(feld, zahl)
    leer=findePosition(feld, 0)
    if not differenz(gewaehlt, leer) in [(0,1),(1,0)]: return feld
    neu=[[feld[0][0],feld[0][1],feld[0][2]],[feld[1][0],feld[1][1],feld[1][2]],[feld[2][0],feld[2][1],feld[2][2]]]
    neu[leer[0]][leer[1]]=zahl                     # 0 überschreiben
    neu[gewaehlt[0]][gewaehlt[1]]=0                # 0 neu setzen
    return neu
#Test: setze(ziel, 8)    

import random
def mische(feld, anzahl):
    # Kopie erzeugen!
    for i in range(anzahl):
        feld=setze(feld, random.randint(1, 9))
    return feld
# Test: mische(ziel, 20)

def zeigeFeld(feld):
    for zeile in feld:
        zeilenString=''
        for wert in zeile:
            if wert!=0: zeilenString+=str(wert)+' '
            else: zeilenString+='  '
        print zeilenString
# Test: zeigeFeld(ziel)

def spiele():
    print "Spiel Beenden mit der Eingabe 9."
    zahl=0
    aktuell=mische(ziel, 500)
    print ziel
    while zahl!=9:
        zeigeFeld(aktuell)
        print "Wähle eine Zahl:"
        zahl=input()
        print
        if not zahl in range(10):
            print "Zahlen zwischen 0 und 9 eingeben!"
        else:
            if zahl==9: return
            aktuell=setze(aktuell, zahl)
            if aktuell==ziel:
                zeigeFeld(aktuell)
                print "Ziel erreicht!"
                return
